package fi.jyu.intellij.comtest.common.util

import com.intellij.ide.SaveAndSyncHandler
import com.intellij.openapi.fileEditor.FileDocumentManager
import com.intellij.openapi.project.Project
import com.intellij.openapi.vfs.VirtualFileManager

// TODO: Move to common module

fun <T> runWithRefresh(project: Project?, action: () -> T): T {
    project?.save()
    FileDocumentManager.getInstance().saveAllDocuments()
    val res = action()
    SaveAndSyncHandler.getInstance().refreshOpenFiles()
    VirtualFileManager.getInstance().refreshWithoutFileWatcher(false)
    return res
}