@file:Suppress("UnstableApiUsage")

package fi.jyu.intellij.comtest.rider.util

import com.intellij.openapi.project.Project
import com.intellij.workspaceModel.ide.WorkspaceModel
import com.jetbrains.rider.projectView.workspace.getFile
import com.jetbrains.rider.projectView.workspace.getSolutionEntity
import java.io.File

val Project.riderSolutionFile: File?
    get() = WorkspaceModel.getInstance(this).getSolutionEntity()?.getFile()

val Project.hasRiderSolution: Boolean
    get() = this.riderSolutionFile != null
